// initialize 386Ex watchdog timer
// and show how to keep it happy
// after a couple seconds, stop feeding it
// to be sure board resets
//
// EW 28 March 2001

#include <dos.h>
#include <bios.h>
#include <stdio.h>

#define WDTRLDH	0xF4C0
#define WDTRLDL	0xF4C2
#define WDTCLR	0xF4C8

void main( void ) {
	long ticks;

// set up WD timer. 1.5 sec * 25MHz ->  37.5E6 cycles -> 0x23C3460
	outport(WDTRLDH, 0x23C);		// write hi byte of counter value
	outport(WDTRLDL, 0x3460);		// write low byte of counter value

	outport(WDTCLR, 0xF01E);		// write enable bytes
	outport(WDTCLR, 0x0FE1);

	ticks=biostime(0,0L);

	printf( "Nice Doggie" );
	while ( biostime(0,0L) < ticks + 40) {	// loop for 40 ticks (~2 seconds)
		outport(WDTCLR, 0xF01E);			// reset the watchdog
		outport(WDTCLR, 0x0FE1);
		putchar('.');						// user feedback
	}

	puts("\nDon't Bite");
	while ( 1 ) { ; }				// loop forever, watchdog should reset board

}
