	page	60,132

Code_seg	Segment
	assume	cs:code_seg,ds:code_seg,ss:code_seg

	org	100h
start:					; Put the initialization code at
	jmp	init			; the end so we don't have to save it

int_no	equ	1Ch			; interrupt number to hook	

;-----------------------------------------------------------------------------
;
;	This is invoked with each interrupt
;
intp:
	push	dx
	push	ax
	mov	dx,0F4C8h
	mov	ax,0F01Eh
	out	dx,ax
	mov	ax,00FE1h
	out	dx,ax
	pop	ax	
	pop	dx	

 	db	0EAh		; far jump
int_off dw	0		; to old tick isr
int_seg dw	0


;-----------------------------------------------------------------------------
;
;	This is our initialization code
;
init:
	push	ds
	mov	ax,0			; point to interrupt vector table
	mov 	ds,ax
	cli				; no ints while changing vectors
	mov	ax,ds:[int_no * 4]		; get int offset
	mov	cs:[int_off],ax		; save it and replace
	mov	ds:[int_no * 4],offset intp

	mov	ax,ds:[int_no * 4 + 2]	; get int segment
	mov	cs:[int_seg],ax		; save it
	mov	ax,cs			; get our segment
	mov	ds:[int_no * 4 + 2],ax	; and install it

	sti				; ints back on
	pop	ds	
	mov	ax,3100h		; TSR function code
	mov 	dx,offset init	 	; get last address used
	mov 	cl,4			; convert to paragraphs
	shr     dx,cl			; by dividing by 16
	inc	dx			; and rounding up by one

	int	21h			; tell dos to do it

code_seg 	ends
	end	start


	mov	cx,2
	mov 	dx,0F4C8h
	lea	si,wdtseq
	cld
	cli	
	rep 	outsw
	sti
	mov	ax,4C00h
	int	21h

wdtseq:
	dw	0F01Eh
	dw	00FE1h


code_seg 	ends
	end	start
